/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-bwi-msgs-0.3.2-0raring-20150610-0611/srv/DoorHandlerInterface.srv
 *
 */


#ifndef BWI_MSGS_MESSAGE_DOORHANDLERINTERFACEREQUEST_H
#define BWI_MSGS_MESSAGE_DOORHANDLERINTERFACEREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace bwi_msgs
{
template <class ContainerAllocator>
struct DoorHandlerInterfaceRequest_
{
  typedef DoorHandlerInterfaceRequest_<ContainerAllocator> Type;

  DoorHandlerInterfaceRequest_()
    : door()
    , open(false)
    , all_doors(false)  {
    }
  DoorHandlerInterfaceRequest_(const ContainerAllocator& _alloc)
    : door(_alloc)
    , open(false)
    , all_doors(false)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _door_type;
  _door_type door;

   typedef uint8_t _open_type;
  _open_type open;

   typedef uint8_t _all_doors_type;
  _all_doors_type all_doors;




  typedef boost::shared_ptr< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct DoorHandlerInterfaceRequest_

typedef ::bwi_msgs::DoorHandlerInterfaceRequest_<std::allocator<void> > DoorHandlerInterfaceRequest;

typedef boost::shared_ptr< ::bwi_msgs::DoorHandlerInterfaceRequest > DoorHandlerInterfaceRequestPtr;
typedef boost::shared_ptr< ::bwi_msgs::DoorHandlerInterfaceRequest const> DoorHandlerInterfaceRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace bwi_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'bwi_planning_common': ['/opt/ros/hydro/share/bwi_planning_common/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'bwi_msgs': ['/tmp/buildd/ros-hydro-bwi-msgs-0.3.2-0raring-20150610-0611/obj-i686-linux-gnu/devel/share/bwi_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "c8a2e070af7337330d3ec9d7ffc50216";
  }

  static const char* value(const ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xc8a2e070af733733ULL;
  static const uint64_t static_value2 = 0x0d3ec9d7ffc50216ULL;
};

template<class ContainerAllocator>
struct DataType< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bwi_msgs/DoorHandlerInterfaceRequest";
  }

  static const char* value(const ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "string door\n\
bool open\n\
bool all_doors\n\
";
  }

  static const char* value(const ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.door);
      stream.next(m.open);
      stream.next(m.all_doors);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct DoorHandlerInterfaceRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::bwi_msgs::DoorHandlerInterfaceRequest_<ContainerAllocator>& v)
  {
    s << indent << "door: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.door);
    s << indent << "open: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.open);
    s << indent << "all_doors: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.all_doors);
  }
};

} // namespace message_operations
} // namespace ros

#endif // BWI_MSGS_MESSAGE_DOORHANDLERINTERFACEREQUEST_H
